### Hierarchy

- BaseForLines
  - SimpleNeighbor

### Implements

- ICacheable

## Index

### Constructors

- constructor

### Properties

- __coverageCount
- __source
- _tilesWithModifier
- anySpritesPresent
- spritesPresent

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- __incrementCoverage
- addCells
- clearCaches
- dependsOnDirection
- evaluate
- matchesCellSimple
- populateMagicOrTiles
- prepareAction
- removeCells
- subscribeToTileChanges
- toKey
- toSourceString
- toString
- updateCells

## Constructors

### constructor

- new SimpleNeighbor(source: IGameCode, tilesWithModifier: Set<SimpleTileWithModifier>, debugFlag: Optional<DEBUG_FLAG>): SimpleNeighbor

- Overrides BaseForLines.constructor

  - Defined in models/rule.ts:1508

  #### Parameters

  - ##### source: IGameCode

  - ##### tilesWithModifier: Set<SimpleTileWithModifier>

  - ##### debugFlag: Optional<DEBUG_FLAG>

  #### Returns SimpleNeighbor

## Properties

### __coverageCount

__coverageCount: Optional<number>

Inherited from BaseForLines.__coverageCount

- Defined in models/BaseForLines.ts:69

### __source

__source: IGameCode

Inherited from BaseForLines.__source

- Defined in models/BaseForLines.ts:68

### _tilesWithModifier

_tilesWithModifier: Set<SimpleTileWithModifier>

- Defined in models/rule.ts:1492

### anySpritesPresent

anySpritesPresent: Set<SpriteBitSet>

- Defined in models/rule.ts:1495

### spritesPresent

spritesPresent: SpriteBitSet

- Defined in models/rule.ts:1494

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Inherited from BaseForLines.__getLineAndColumnRange

  - Defined in models/BaseForLines.ts:96

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Inherited from BaseForLines.__getSourceLineAndColumn

  - Defined in models/BaseForLines.ts:81

  #### Returns object

  - ##### colNum: number

  - ##### line: string

  - ##### lineNum: number

  - ##### nextLine: null | string

  - ##### prevLine: null | string

### __incrementCoverage

- __incrementCoverage(): void

- Inherited from BaseForLines.__incrementCoverage

  - Defined in models/BaseForLines.ts:104

  #### Returns void

### addCells

- addCells(t: SimpleTileWithModifier, sprite: GameSprite, cells: Iterable<Cell>, wantsToMove: Optional<RULE_DIRECTION>): void

- - Defined in models/rule.ts:1851

  #### Parameters

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cells: Iterable<Cell>

  - ##### wantsToMove: Optional<RULE_DIRECTION>

  #### Returns void

### clearCaches

- clearCaches(): void

- - Defined in models/rule.ts:1816

  #### Returns void

### dependsOnDirection

- dependsOnDirection(): boolean

- - Defined in models/rule.ts:1605

  #### Returns boolean

### evaluate

- evaluate(actionNeighbor: SimpleNeighbor, cell: Cell, magicOrTiles: Map<IGameTile, Set<GameSprite>>): null | CellMutation

- - Defined in models/rule.ts:1783

  #### Parameters

  - ##### actionNeighbor: SimpleNeighbor

  - ##### cell: Cell

  - ##### magicOrTiles: Map<IGameTile, Set<GameSprite>>

  #### Returns null | CellMutation

### matchesCellSimple

- matchesCellSimple(cell: Cell): boolean

- - Defined in models/rule.ts:1847

  #### Parameters

  - ##### cell: Cell

  #### Returns boolean

### populateMagicOrTiles

- populateMagicOrTiles(cell: Cell, magicOrTiles: Map<IGameTile, Set<GameSprite>>): void

- - Defined in models/rule.ts:1824

  #### Parameters

  - ##### cell: Cell

  - ##### magicOrTiles: Map<IGameTile, Set<GameSprite>>

  #### Returns void

### prepareAction

- prepareAction(actionNeighbor: SimpleNeighbor): void

- - Defined in models/rule.ts:1609

  #### Parameters

  - ##### actionNeighbor: SimpleNeighbor

  #### Returns void

### removeCells

- removeCells(t: SimpleTileWithModifier, sprite: GameSprite, cells: Iterable<Cell>): void

- - Defined in models/rule.ts:1872

  #### Parameters

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cells: Iterable<Cell>

  #### Returns void

### subscribeToTileChanges

- subscribeToTileChanges(bracket: ISimpleBracket, index: number): void

- - Defined in models/rule.ts:1833

  #### Parameters

  - ##### bracket: ISimpleBracket

  - ##### index: number

  #### Returns void

### toKey

- toKey(): string

- - Defined in models/rule.ts:1601

  #### Returns string

### toSourceString

- toSourceString(): string

- Inherited from BaseForLines.toSourceString

  - Defined in models/BaseForLines.ts:90

  #### Returns string

### toString

- toString(): string

- Inherited from BaseForLines.toString

  - Defined in models/BaseForLines.ts:85

  #### Returns string

### updateCells

- updateCells(t: SimpleTileWithModifier, sprite: GameSprite, cells: Iterable<Cell>, wantsToMove: RULE_DIRECTION): void

- - Defined in models/rule.ts:1869

  #### Parameters

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cells: Iterable<Cell>

  - ##### wantsToMove: RULE_DIRECTION

  #### Returns void

Generated using TypeDoc